%global commit db290dc9e65e07147a1cddff742be5e32d07a53d
%global snapdate 20230505

Name:           c4log
Summary:        C++ type-safe logging, mean and lean
Version:        0.0.1^%{snapdate}git%(c='%{commit}'; echo "${c:0:7}")
%global so_version 0.0.1
Release:    1%{?dist}

License:        MIT
URL:            https://github.com/biojppm/c4log
Source0:         %{url}/archive/%{commit}/c4log-%{commit}.tar.gz

Patch0:          c4log-b8b86f3-external-c4core.patch

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  c4project
BuildRequires:  ninja-build

BuildRequires:  cmake(c4core)

BuildRequires:  doctest-devel
BuildRequires:  doctest-static

%description
%{summary}.


%package devel
Summary:        Development files for c4log

Requires:       c4log = %{version}-%{release}
Requires:       c4core-devel

%description devel
The c4log-devel package contains libraries and header files for developing
applications that use c4log.


%prep
%autosetup -n c4log-%{commit} -p1


ln -s '%{_datadir}/cmake/c4project' ext/c4core/cmake

sed -r -i 's/\bdoctest\b//' test/CMakeLists.txt


%build
%cmake -GNinja \
  -DC4LOG_CACHE_DOWNLOAD_DOCTEST:PATH=/ \
  -DC4LOG_BUILD_TESTS=ON
%cmake_build


%install
%cmake_install
if [ '%{_libdir}' != '%{_prefix}/lib' ]
then
  mkdir -p '%{buildroot}%{_libdir}'
  mv -v %{buildroot}%{_prefix}/lib/libc4log.so* '%{buildroot}%{_libdir}/'
  mkdir -p '%{buildroot}%{_libdir}/cmake'
  mv -v %{buildroot}%{_prefix}/lib/cmake/c4log '%{buildroot}%{_libdir}/cmake/'
  find %{buildroot}%{_libdir}/cmake/c4log -type f -name '*.cmake' -print0 |
    xargs -r -t -0 sed -r -i "s@/lib/@/$(basename '%{_libdir}')/@"
fi


%check
%cmake_build --target c4log-test-run-verbose


%files
%license LICENSE.txt
%doc README.md
%{_libdir}/libc4log.so.%{so_version}


%files devel
%{_includedir}/c4/log/
%{_libdir}/libc4log.so
%{_libdir}/cmake/c4log/


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.0.1^20230505gitdb290dc-1
- initial build
